#ifndef __SQTJS_OBJ_H_
#define __SQTJS_OBJ_H_

#include <sqobjectclass.h>

/**
 * ggIuWFNgێsquirrelNX
 */
class TJSObject : public sqobject::Object, iTJSNativeInstance {

public:
	/**
	 * p
	 */
	static void init(HSQUIRRELVM vm);

	/**
	 * pp
	 */
	static void done(HSQUIRRELVM vm);

	// ---------------------------------------------------------------

	/**
	 * call p̌
	 * TJSCX^XsquirrelCX^X̃\bh𒼐ڌĂяo
	 */
	static tjs_error call(tjs_uint32 flag, const tjs_char * membername, tjs_uint32 *hint,
						  tTJSVariant *result,
						  tjs_int numparams, tTJSVariant **param, iTJSDispatch2 *objthis);
	
	/**
	 * missing p̌
	 * TJSCX^XɃo݂Ȃꍇ squirrelCX^XQƂ
	 */
	static tjs_error missing(tjs_uint32 flag, const tjs_char * membername, tjs_uint32 *hint,
							 tTJSVariant *result,
							 tjs_int numparams, tTJSVariant **param, iTJSDispatch2 *objthis);

	// ---------------------------------------------------------------

	
	/**
	 * X^bN̋ggIuWFNg̎擾
	 * @param v squirrelVM
	 * @param idx CfbNX
	 * @param variant i[
	 * @return i[ true
	 */
	static bool getVariant(HSQUIRRELVM v, SQInteger idx, tTJSVariant *variant);

	/**
	 * X^bNւ̋ggIuWFNg̓o^
	 * @parma variant IuWFNg
	 * @return o^ true
	 */
	static bool pushVariant(HSQUIRRELVM v, tTJSVariant &variant);

	// ---------------------------------------------------------------
	
	/**
	 * ggNX squirrel NX𐶐
	 * @param v squirrelVM
	 */
	static SQRESULT createTJSClass(HSQUIRRELVM v);

	// ---------------------------------------------------------------
	
	/**
	 * TJSIuWFNgp̃\bh
	 * 1 IuWFNg
	 * 2`z
	 * Rϐ1 \bh
	 */
	static SQRESULT tjsInvoker(HSQUIRRELVM v);

	/**
	 * TJSIuWFNgp̃vpeBQb^[
	 * 1 IuWFNg
	 * Rϐ1 vpeB
	 */
	static SQRESULT tjsGetter(HSQUIRRELVM v);

	/**
	 * TJSIuWFNgp̃vpeBZb^[
	 * 1 IuWFNg
	 * 2 ݒl
	 * Rϐ1 vpeB
	 */
	static SQRESULT tjsSetter(HSQUIRRELVM v);

	/**
	 * TJSIuWFNgp̐ÓI\bh
	 * 1 IuWFNg
	 * 2`z
	 * Rϐ1 NX
	 * Rϐ2 o
	 */
	static SQRESULT tjsStaticInvoker(HSQUIRRELVM v);

	/**
	 * TJSIuWFNgp̐ÓIvpeBQb^[
	 * 1 IuWFNg
	 * Rϐ1 NX
	 * Rϐ2 vpeB
	 */
	static SQRESULT tjsStaticGetter(HSQUIRRELVM v);

	/**
	 * TJSIuWFNgp̐ÓIvpeBZb^[
	 * 1 IuWFNg
	 * 2 ݒl
	 * Rϐ1 NX
	 * Rϐ2 vpeB
	 */
	static SQRESULT tjsStaticSetter(HSQUIRRELVM v);

	/**
	 * TJSIuWFNg̗LmF
	 * 1 IuWFNg
	 */
	static SQRESULT tjsIsValid(HSQUIRRELVM v);

	/**
	 * TJSIuWFNgɑ΂I[oCh
	 * 1 IuWFNg
	 * 2 O
	 * 3 squirrelN[W
	 */
	static SQRESULT tjsOverride(HSQUIRRELVM v);

protected:
	/**
	 * RXgN^
	 * @param v squirrel VM
	 * @param idx IuWFNgQƌCfbNX
	 * @param instance oChΏۂTJSIuWFNg
	 */
	TJSObject(HSQUIRRELVM v, int idx, tTJSVariant &instance);
	
	// fXgN^
	~TJSObject();

	/**
	 * j
	 */
	void invalidate();
	
	/**
	 * IuWFNg̃[T
	 */
	static SQRESULT release(SQUserPointer up, SQInteger size);

	/**
	 * TJSIuWFNg̃RXgN^
	 * TJSIuWFNg̃RXgN^
	 * 1 IuWFNg
	 * 2` 
	 * Rϐ1 NX
	 */
	static SQRESULT tjsConstructor(HSQUIRRELVM v);

private:
	// NativeClass ID
	static int classId;
	
	// ΏۃIuWFNg
	tTJSVariant instance;
	
public:
	// NativeInstance Ήpo
	virtual tjs_error TJS_INTF_METHOD Construct(tjs_int numparams, tTJSVariant **param, iTJSDispatch2 *tjs_obj);
	virtual void TJS_INTF_METHOD Invalidate();
	virtual void TJS_INTF_METHOD Destruct();
};

#endif
